<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#              Made by  :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 
if (isset($_GET['id'])) {
  $id = abs(intval($_GET['id']));
} else {
  $id = 0;
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 

show_title('news.png', 'Новости сайта');
$config['newtitle'] = 'Новости сайта';

switch ($act):
# ###########################################################################################
# #                                    Главная страница                                    ##
# ###########################################################################################
case 'index':

  $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `news`;");

  if ($total > 0) {
    if ($start >= $total) {
      $start = 0;
    } 

    $querynews = DB :: $dbh -> query("SELECT * FROM `news` ORDER BY `news_id` DESC LIMIT " . $start . ", " . $config['postnews'] . ";");

    while ($data = $querynews -> fetch()) {
      echo '<div class="b">';
      echo $data['news_closed'] == 0 ? '<img src="../images/img/document_plus.gif" alt="image" /> ' : '<img src="../images/img/document_minus.gif" alt="image" /> ';
      echo '<b><a href="index.php?act=read&amp;id=' . $data['news_id'] . '&amp;' . SID . '">' . $data['news_title'] . '</a></b><small> (' . date_fixed($data['news_time']) . ')</small></div>';
      echo '<div>' . bb_code($data['news_text']) . '<br />';
      echo 'Разместил: <a href="../pages/anketa.php?uz=' . $data['news_author'] . '&amp;' . SID . '"> ' . nickname($data['news_author']) . ' </a><br />';
      echo '<a href="index.php?act=comments&amp;id=' . $data['news_id'] . '&amp;' . SID . '">Комментарии</a> (' . $data['news_comments'] . ') ';
      echo '<a href="index.php?act=end&amp;id=' . $data['news_id'] . '&amp;' . SID . '">&raquo;</a></div>';
    } 

    page_jumpnavigation('index.php?', $config['postnews'], $start, $total);
    page_strnavigation('index.php?', $config['postnews'], $start, $total);
  } else {
    show_error('Новостей еще нет!');
  } 

  echo '<img src="../images/img/rss.gif" alt="image" /> <a href="rss.php?' . SID . '">RSS подписка</a><br />';
  echo '<img src="../images/img/balloon.gif" alt="image" /> <a href="comments.php?' . SID . '">Комментарии</a><br />';
  break;
# ###########################################################################################
# #                                     Чтение новости                                     ##
# ###########################################################################################
case 'read':

  $querynews = DB :: $dbh -> query("SELECT * FROM `news` WHERE `news_id`=? LIMIT 1;", array($id));
  $data = $querynews -> fetch();

  if ($data > 0) {
    $config['newtitle'] = $data['news_title'];

    echo '<div class="b"><img src="../images/img/files.gif" alt="image" /> ';
    echo '<b>' . $data['news_title'] . '</b><small> (' . date_fixed($data['news_time']) . ')</small></div>';
    echo '<div>' . bb_code($data['news_text']) . '<br />';
    echo 'Разместил: <a href="../pages/anketa.php?uz=' . $data['news_author'] . '&amp;' . SID . '"> ' . nickname($data['news_author']) . ' </a><br />';
    echo '<a href="index.php?act=comments&amp;id=' . $data['news_id'] . '&amp;' . SID . '">Комментарии</a> (' . $data['news_comments'] . ') ';
    echo '<a href="index.php?act=end&amp;id=' . $data['news_id'] . '&amp;' . SID . '">&raquo;</a></div>';
  } else {
    show_error('Ошибка! Выбранная вами новость не существует, возможно она была удалена!');
  } 

  echo '<br /><img src="../images/img/back.gif" alt="image" /> <a href="index.php?' . SID . '">К новостям</a><br />';
  break;
# ###########################################################################################
# #                                     Комментарии                                        ##
# ###########################################################################################
case 'comments':

  $querynews = DB :: $dbh -> query("SELECT * FROM `news` WHERE `news_id`=? LIMIT 1;", array($id));
  $datanews = $querynews -> fetch();

  if ($datanews > 0) {
    $config['newtitle'] = 'Комментарии - ' . $datanews['news_title'];

    echo '<img src="../images/img/news.gif" alt="image" /> <b>' . $datanews['news_title'] . '</b><br /><br />';

    echo '<a href="#down"><img src="../images/img/downs.gif" alt="image" /></a> ';
    echo '<a href="index.php?act=comments&amp;id=' . $id . '&amp;rand=' . mt_rand(100, 999) . '&amp;' . SID . '">Обновить</a><hr />';

    $total = DB :: $dbh -> querySingle("SELECT count(*) FROM `commnews` WHERE `commnews_news_id`=?", array($id));

    if ($total > 0) {
      if ($start >= $total) {
        $start = 0;
      } 

      $is_admin = is_admin(array(101, 102, 103, 105));
      if ($is_admin) {
        echo '<form action="index.php?act=del&amp;id=' . $id . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      } 

      $querycomm = DB :: $dbh -> query("SELECT * FROM `commnews` WHERE `commnews_news_id`=? ORDER BY `commnews_time` ASC LIMIT " . $start . ", " . $config['postnews'] . ";", array($id));

      while ($data = $querycomm -> fetch()) {
        echo '<div class="b">';
        echo '<div class="img">';

        if ($is_admin) {
          echo '<input type="checkbox" name="del[]" value="' . $data['commnews_id'] . '" /> ';
        } 

        echo user_avatars($data['commnews_author']) . '</div>';

        echo '<b><a href="../pages/anketa.php?uz=' . $data['commnews_author'] . '&amp;' . SID . '">' . nickname($data['commnews_author']) . '</a></b>';
        echo '<small> (' . date_fixed($data['commnews_time']) . ')</small><br />';
        echo user_title($data['commnews_author']) . ' ' . user_online($data['commnews_author']) . '</div>';

        echo '<div>' . bb_code($data['commnews_text']) . '<br />';

        if (is_admin() || empty($config['anonymity'])) {
          echo '<span class="data">(' . $data['commnews_brow'] . ', ' . $data['commnews_ip'] . ')</span>';
        } 

        echo '</div>';
      } 

      if ($is_admin) {
        echo '<br /><input type="submit" value="Удалить выбранное" /></form>';
      } 

      page_jumpnavigation('index.php?act=comments&amp;id=' . $id . '&amp;', $config['postnews'], $start, $total);
      page_strnavigation('index.php?act=comments&amp;id=' . $id . '&amp;', $config['postnews'], $start, $total);
    } else {
      show_error('Комментариев еще нет!');
    } 

    if (is_user()) {
      if (empty($datanews['news_closed'])) {
        echo '<div class="form" id="form"><form action="index.php?act=add&amp;id=' . $id . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
        echo '<b>Сообщение:</b><br />';
        echo '<textarea cols="25" rows="3" name="msg"></textarea><br />';
        echo '<input type="submit" value="Написать" /></form></div>';

        echo '<br /><a href="#up"><img src="../images/img/ups.gif" alt="image" /></a> ';
        echo '<a href="../pages/rules.php?' . SID . '">Правила</a> / ';
        echo '<a href="../pages/smiles.php?' . SID . '">Смайлы</a> / ';
        echo '<a href="../pages/tegi.php?' . SID . '">Теги</a><br /><br />';
      } else {
        show_error('Комментирование данной новости закрыто!');
      } 
    } else {
      show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
    } 
  } else {
    show_error('Ошибка! Выбранная новость не существует, возможно она была удалена!');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?' . SID . '">К новостям</a><br />';
  break;
# ###########################################################################################
# #                                Добавление комментариев                                 ##
# ###########################################################################################
case 'add':

  $uid = check($_GET['uid']);
  $msg = check($_POST['msg']);

  if (is_user()) {
    if ($uid == $_SESSION['token']) {
      if (utf_strlen(trim($msg)) >= 5 && utf_strlen($msg) < 1000) {
        $querynews = DB :: $dbh -> query("SELECT * FROM `news` WHERE `news_id`=? LIMIT 1;", array($id));
        $data = $querynews -> fetch();

        if (!empty($data)) {
          if (empty($data['news_closed'])) {
            if (is_quarantine($log)) {
              if (is_flood($log)) {
                $msg = no_br($msg);
                $msg = antimat($msg);
                $msg = smiles($msg);

                DB :: $dbh -> query("INSERT INTO `commnews` (`commnews_news_id`, `commnews_text`, `commnews_author`, `commnews_time`, `commnews_ip`, `commnews_brow`) VALUES (?, ?, ?, ?, ?, ?);", array($id, $msg, $log, SITETIME, $ip, $brow));

                DB :: $dbh -> query("DELETE FROM `commnews` WHERE `commnews_news_id`=? AND `commnews_time` < (SELECT MIN(`commnews_time`) FROM (SELECT `commnews_time` FROM `commnews` WHERE `commnews_news_id`=? ORDER BY `commnews_time` DESC LIMIT " . $config['maxkommnews'] . ") AS del);", array($id, $id));

                DB :: $dbh -> query("UPDATE `news` SET `news_comments`=`news_comments`+1 WHERE `news_id`=?;", array($id));
                DB :: $dbh -> query("UPDATE `users` SET `users_allcomments`=`users_allcomments`+1, `users_point`=`users_point`+1, `users_money`=`users_money`+5 WHERE `users_login`=?", array($log));

                $_SESSION['note'] = 'Сообщение успешно добавлено!';
                header ("Location: index.php?act=end&id=$id&" . SID);
                exit;
              } else {
                show_error('Антифлуд! Разрешается отправлять сообщения раз в ' . flood_period() . ' секунд!');
              } 
            } else {
              show_error('Карантин! Вы не можете писать в течении ' . round($config['karantin'] / 3600) . ' часов!');
            } 
          } else {
            show_error('Ошибка! Комментирование данной новости запрещено!');
          } 
        } else {
          show_error('Ошибка! Выбранная вами новость не существует, возможно она была удалена!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_login('Вы не авторизованы, чтобы добавить сообщение, необходимо');
  } 

  echo '<img src="../images/img/reload.gif" alt="image" /> <a href="index.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?' . SID . '">К новостям</a><br />';
  break;
# ###########################################################################################
# #                                 Удаление комментариев                                  ##
# ###########################################################################################
case 'del':

  $uid = check($_GET['uid']);
  if (isset($_POST['del'])) {
    $del = intar($_POST['del']);
  } else {
    $del = 0;
  } 

  if (is_admin(array(101, 102, 103, 105))) {
    if ($uid == $_SESSION['token']) {
      if ($del > 0) {
        $del = implode(',', $del);

        $delcomments = DB :: $dbh -> exec("DELETE FROM `commnews` WHERE `commnews_id` IN (" . $del . ") AND `commnews_news_id`=" . $id . ";");
        DB :: $dbh -> query("UPDATE `news` SET `news_comments`=`news_comments`-? WHERE `news_id`=?;", array($delcomments, $id));

        $_SESSION['note'] = 'Выбранные сообщения успешно удалены!';
        header("location: index.php?act=comments&id=$id&start=$start&" . SID);
        exit;
      } else {
        show_error('Ошибка! Отстутствуют выбранные сообщения для удаления!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 
  } else {
    show_error('Ошибка! Удалять сообщения могут только модераторы!');
  } 

  echo '<img src="../images/img/reload.gif" alt="image" /> <a href="index.php?act=comments&amp;id=' . $id . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?' . SID . '">К новостям</a><br />';
  break;
# ###########################################################################################
# #                             Переадресация на последнюю страницу                        ##
# ###########################################################################################
case 'end':

  $query = DB :: $dbh -> queryFetch("SELECT `news_id`, `news_comments` FROM `news` WHERE `news_id`=? LIMIT 1;", array($id));

  if (!empty($query)) {
    $end = floor(($query['news_comments'] - 1) / $config['postnews']) * $config['postnews'];

    header ("Location: index.php?act=comments&id=$id&start=$end&" . SID);
    exit;
  } else {
    show_error('Ошибка! Данной новости не существует!');
  } 

  echo '<img src="../images/img/back.gif" alt="image" /> <a href="index.php?' . SID . '">К новостям</a><br />';
  break;

default:
  header("location: index.php?" . SID);
  exit;
  endswitch;

  echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a>';

  include_once ('../themes/' . $config['themes'] . '/foot.php');

  ?>